TarInputStream (Apache Ant API)
Date: 2018-07-10

org.apache.tools.tar

## Class TarInputStream

- java.lang.Object
- - java.io.InputStream
  - - java.io.FilterInputStream
    - - org.apache.tools.tar.TarInputStream

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable

      public class TarInputStream
      extends java.io.FilterInputStream

  The TarInputStream reads a UNIX tar archive as an InputStream. methods are provided to position at each successive entry in the archive, and the read each entry as a normal input stream using read().

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected TarBuffer` | `buffer`
    `protected TarEntry` | `currEntry`
    `protected boolean` | `debug`
    `protected long` | `entryOffset`
    `protected long` | `entrySize`
    `protected boolean` | `hasHitEOF`
    `protected byte[]` | `oneBuf` This contents of this array is not used at all in this class, it is only here to avoid repeated object creation during calls to the no-arg read method.
    `protected byte[]` | `readBuf`

    - ### Fields inherited from class java.io.FilterInputStream

      `in`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TarInputStream(java.io.InputStream is)` Constructor for TarInputStream.
    `TarInputStream(java.io.InputStream is, int blockSize)` Constructor for TarInputStream.
    `TarInputStream(java.io.InputStream is, int blockSize, int recordSize)` Constructor for TarInputStream.
    `TarInputStream(java.io.InputStream is, int blockSize, int recordSize, java.lang.String encoding)` Constructor for TarInputStream.
    `TarInputStream(java.io.InputStream is, int blockSize, java.lang.String encoding)` Constructor for TarInputStream.
    `TarInputStream(java.io.InputStream is, java.lang.String encoding)` Constructor for TarInputStream.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Get the available data that can be read from the current entry in the archive.
    `boolean` | `canReadEntryData(TarEntry te)` Whether this class is able to read the given entry.
    `void` | `close()` Closes this stream.
    `void` | `copyEntryContents(java.io.OutputStream out)` Copies the contents of the current tar archive entry directly into an output stream.
    `protected byte[]` | `getLongNameData()` Get the next entry in this tar archive as longname data.
    `TarEntry` | `getNextEntry()` Get the next entry in this tar archive.
    `int` | `getRecordSize()` Get the record size being used by this stream's TarBuffer.
    `void` | `mark(int markLimit)` Since we do not support marking just yet, we do nothing.
    `boolean` | `markSupported()` Since we do not support marking just yet, we return false.
    `int` | `read()` Reads a byte from the current tar archive entry.
    `int` | `read(byte[] buf, int offset, int numToRead)` Reads bytes from the current tar archive entry.
    `void` | `reset()` Since we do not support marking just yet, we do nothing.
    `void` | `setDebug(boolean debug)` Sets the debugging flag.
    `long` | `skip(long numToSkip)` Skip bytes in the input buffer.

    - ### Methods inherited from class java.io.FilterInputStream

      `read`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### debug

          protected boolean debug

    - #### hasHitEOF

          protected boolean hasHitEOF

    - #### entrySize

          protected long entrySize

    - #### entryOffset

          protected long entryOffset

    - #### readBuf

          protected byte[] readBuf

    - #### buffer

          protected TarBuffer buffer

    - #### currEntry

          protected TarEntry currEntry

    - #### oneBuf

          protected byte[] oneBuf

      This contents of this array is not used at all in this class, it is only here to avoid repeated object creation during calls to the no-arg read method.

  - ### Constructor Detail

    - #### TarInputStream

          public TarInputStream(java.io.InputStream is)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use

    - #### TarInputStream

          public TarInputStream(java.io.InputStream is,
                                java.lang.String encoding)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `encoding` - name of the encoding to use for file names

    - #### TarInputStream

          public TarInputStream(java.io.InputStream is,
                                int blockSize)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `blockSize` - the block size to use

    - #### TarInputStream

          public TarInputStream(java.io.InputStream is,
                                int blockSize,
                                java.lang.String encoding)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `blockSize` - the block size to use
        `encoding` - name of the encoding to use for file names

    - #### TarInputStream

          public TarInputStream(java.io.InputStream is,
                                int blockSize,
                                int recordSize)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `blockSize` - the block size to use
        `recordSize` - the record size to use

    - #### TarInputStream

          public TarInputStream(java.io.InputStream is,
                                int blockSize,
                                int recordSize,
                                java.lang.String encoding)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `blockSize` - the block size to use
        `recordSize` - the record size to use
        `encoding` - name of the encoding to use for file names

  - ### Method Detail

    - #### setDebug

          public void setDebug(boolean debug)

      Sets the debugging flag.
      Parameters:
        `debug` - True to turn on debugging.

    - #### close

          public void close()
                     throws java.io.IOException

      Closes this stream. Calls the TarBuffer's close() method.
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `java.io.FilterInputStream`
      Throws:
        `java.io.IOException` - on error

    - #### getRecordSize

          public int getRecordSize()

      Get the record size being used by this stream's TarBuffer.
      Returns:
        The TarBuffer record size.

    - #### available

          public int available()
                        throws java.io.IOException

      Get the available data that can be read from the current entry in the archive. This does not indicate how much data is left in the entire archive, only in the current entry. This value is determined from the entry's size header field and the amount of data already read from the current entry. Integer.MAX_VALUE is returned in case more than Integer.MAX_VALUE bytes are left in the current entry in the archive.
      Overrides:
        `available` in class `java.io.FilterInputStream`
      Returns:
        The number of available bytes for the current entry.
      Throws:
        `java.io.IOException` - for signature

    - #### skip

          public long skip(long numToSkip)
                    throws java.io.IOException

      Skip bytes in the input buffer. This skips bytes in the current entry's data, not the entire archive, and will stop at the end of the current entry's data if the number to skip extends beyond that point.
      Overrides:
        `skip` in class `java.io.FilterInputStream`
      Parameters:
        `numToSkip` - The number of bytes to skip.
      Returns:
        the number actually skipped
      Throws:
        `java.io.IOException` - on error

    - #### markSupported

          public boolean markSupported()

      Since we do not support marking just yet, we return false.
      Overrides:
        `markSupported` in class `java.io.FilterInputStream`
      Returns:
        False.

    - #### mark

          public void mark(int markLimit)

      Since we do not support marking just yet, we do nothing.
      Overrides:
        `mark` in class `java.io.FilterInputStream`
      Parameters:
        `markLimit` - The limit to mark.

    - #### reset

          public void reset()

      Since we do not support marking just yet, we do nothing.
      Overrides:
        `reset` in class `java.io.FilterInputStream`

    - #### getNextEntry

          public TarEntry getNextEntry()
                                throws java.io.IOException

      Get the next entry in this tar archive. This will skip over any remaining data in the current entry, if there is one, and place the input stream at the header of the next entry, and read the header and instantiate a new TarEntry from the header bytes and return that entry. If there are no more entries in the archive, null will be returned to indicate that the end of the archive has been reached.
      Returns:
        The next TarEntry in the archive, or null.
      Throws:
        `java.io.IOException` - on error

    - #### getLongNameData

          protected byte[] getLongNameData()
                                    throws java.io.IOException

      Get the next entry in this tar archive as longname data.
      Returns:
        The next entry in the archive as longname data, or null.
      Throws:
        `java.io.IOException` - on error

    - #### read

          public int read()
                   throws java.io.IOException

      Reads a byte from the current tar archive entry. This method simply calls read(byte[], int, int).
      Overrides:
        `read` in class `java.io.FilterInputStream`
      Returns:
        The byte read, or -1 at EOF.
      Throws:
        `java.io.IOException` - on error

    - #### read

          public int read(byte[] buf,
                          int offset,
                          int numToRead)
                   throws java.io.IOException

      Reads bytes from the current tar archive entry. This method is aware of the boundaries of the current entry in the archive and will deal with them as if they were this stream's start and EOF.
      Overrides:
        `read` in class `java.io.FilterInputStream`
      Parameters:
        `buf` - The buffer into which to place bytes read.
        `offset` - The offset at which to place bytes read.
        `numToRead` - The number of bytes to read.
      Returns:
        The number of bytes read, or -1 at EOF.
      Throws:
        `java.io.IOException` - on error

    - #### copyEntryContents

          public void copyEntryContents(java.io.OutputStream out)
                                 throws java.io.IOException

      Copies the contents of the current tar archive entry directly into an output stream.
      Parameters:
        `out` - The OutputStream into which to write the entry's data.
      Throws:
        `java.io.IOException` - on error

    - #### canReadEntryData

          public boolean canReadEntryData(TarEntry te)

      Whether this class is able to read the given entry.

      May return false if the current entry is a sparse file.

      Parameters:
        `te` - TarEntry
      Returns:
        boolean